
String.prototype.x = function(num){
	if(num){
		var tmp ="";for(var i=1;i<num;i++){tmp+=this}
		return tmp
	}return this+this
};
String.prototype.xx = function(){return this+this+this};
String.prototype.xxx = function(){return this+this+this+this};
//マークアップルールたち
markup = new Object();

markup = {
	wiki : 
	function (buf){
		line = buf.split(/\n/);
		var html="";
		var toc="";
		var closetag="";
		urlrep="<b class=outer>$1</b>";
		var regURL = new RegExp("").compile("(http:[-_.!~*'()a-zA-Z0-9;/?:@&=+$,%#]+)","g");
		for(var i=0;i<line.length;i++){
			tmp = line[i].replace(/[\r\t]/g,"");
			line[i] = tmp;
			var fc = tmp.charAt(0);
			//エスケープ
			tmp = tmp.replace(/>/g,"&gt;")
				.replace(/</g,"&lt;")
				.replace(regURL,urlrep);
			cm=new RegExp(",","g");

			//整形
			switch (fc){
				case " ":
					tmp="<pre>"+tmp.substring(1)+"</pre>";break;
				case "*":
					if(tmp.indexOf("****") == 0){tmp="<h5>"+tmp.substring(4)+"</h5>";}
					else if(tmp.indexOf("***") == 0){tmp="<h4>"+tmp.substring(3)+"</h4>";}
					else if(tmp.indexOf("**") == 0){tmp="<h3>"+tmp.substring(2)+"</h3>";}
					else {tmp="<h2>"+tmp.substring(1)+"</h2>";}
					tmp=closetag+"<div id=\"line"+i+"\">"+tmp;
					closetag="</div>"
					break;
				case "-":
					if(tmp.indexOf("----") == 0){tmp="<hr>";break}
					if(tmp.indexOf("---") == 0){tmp="<ul><ul><ul><li>"+tmp.substring(3)+"</li></ul></ul></ul>";break}
					if(tmp.indexOf("--") == 0){tmp="<ul><ul><li>"+tmp.substring(2)+"</li></ul></ul>";break}
					tmp="<ul><li id=\"line"+i+"\">"+tmp.substring(1)+"</li></ul>";break;
				case "+":
					if(tmp.charAt(1) == "+"){tmp="<ol><ol><li>"+tmp.substring(2)+"</li></ol></ol>"}
					else{tmp="<ol><li>"+tmp.substring(1)+"</li></ol>"}break;
				case ":":
					if(tmp.substring(1).indexOf(":") >= 1){tmp="<dl><dt>"+tmp.substring(1).replace(/:/,"<dd>")+"</dl>";break;}
					else{tmp=tmp+"<br>";break}
				case ",":
					if(tmp.substring(1).indexOf(",") >= 1){
					tmp="<table><tr>"+tmp.replace(cm,"<td>")+"</table>";break;}
					else{tmp=tmp+"<br>";break}
				case "|":
					if(tmp.substring(1).indexOf("|") >= 1){
					tmp="<table><tr>"+tmp.replace(/\|/g,"<td>")+"</table>";break;
					}else{tmp=tmp+"<br>";break}
				case ">":
					if(tmp.indexOf(">>>>") == 0){
						tmp="<blockquote>".xxx()+tmp.substring(4)+"</blockquote>".xxx();break}
					if(tmp.indexOf(">>>") == 0){
						tmp="<blockquote>".xx()+tmp.substring(3)+"</blockquote>".xx();break}
					if(tmp.indexOf(">>") == 0){
						tmp="<blockquote>".x()+tmp.substring(2)+"</blockquote>".x();break}
					tmp="<blockquote>"+tmp.substring(4)+"</blockquote>";break;
//strong追加
				case '"':
					if(tmp.indexOf('""') == 0){
						tmp="<strong>"+ tmp.replace(/\"\"/g,"") +"</strong><br>"
					}break;
				default:tmp="<span id=\"line"+i+"\">"+tmp+"</span><br>";
			}
			html+=tmp;
		}
		loop=new RegExp("(</pre><pre>)|(</blockquote><blockquote>)|(</ol><ol>)|(</ul><ul>)|(</dl><dl>)|(</table><table>)","g");
		html = html.replace(loop,"\n");
		html+= closetag;
		return html;
	},
	//TOCをHTMLに変換、共通化可能。
	tochtml : function(toc){
		var html = "";
		for(var i=0;i<toc.length;i++){
			html += "<span id='toc_"+ toc[i].num +"'>"
			+"<a href=#line" + toc[i].num + ">"+ "　".x(toc[i].level) + toc[i].text + "</a></span>";
		}
		return html;
	},
	toc_wiki : function(buf){
		var line = buf.split(/\n/);
		var toc = new Array();
		for (var i=0;i<line.length;i++){
			if(line[i].charAt(0) == "*"){
				//count++;
				var tmp = line[i];
				var l = 0;
				if(tmp.indexOf("****") == 0){
					l=4
				}else if(tmp.indexOf("***") == 0){
					l=3
				}else if(tmp.indexOf("**") == 0){
					l=2
				}else{
					l=1
				}
				toc.push({
					num:i,text:line[i].replace(/^[\*]*/,""),level:l
				});
			}
		}
		return toc;
	},
	plain : function(buf){ //ただのテキスト
		return "<pre class=break>" + buf + "</pre>";
	}
};

//テキストを扱う
function FormatText(o){
	this.set = function(o){for(i in o){this[i]=o[i]}};
	if(o){for(i in o){this[i]=o[i]}}
	this.rule = "wiki";
	this.output = function(){
		return markup[this.rule](this.text)
	};
	this.toc = function(){
		return markup["toc_" + this.rule](this.text)
	};

	return this;
}



//オートリンクすべき単語を羅列。
/*
	linklist = [
		text :{href:href,tip:tooltip},
		text :{href:href,tip:tooltip}
	]
*/
function AutoLink(o){
	//本文、this.text;
	//リンクリスト、this.linklist;
	//関連リンクを抽出、this.related();

	this.related_link = new Array();
	this.set = function(o){for(i in o){this[i]=o[i]}};
	this.links_to = function(){
		return this.related_link;
	};
	this.dolink = function(){
		this.related_link = new Array();
		var html   = this.text;
		var linked = new Array();
		if(!this.linklist){return this.text}
		for(var i=0; i < this.linklist.length; ++i){
			var link  = this.linklist[i];
			var reg = new RegExp(link, "g");
			var ot = "<b class=al>" + link + "</b>";
			if(linked[link]){continue}
			if(html.indexOf(link) >= 0){
				html = html.replace(reg,ot);
				this.related_link.push(link);
				linked[link]= "1" ;
			}
		}
		var tmp_div = document.createElement("div");
		tmp_div.innerHTML = html;
		var autolinks = tmp_div.getElementsByTagName("b");
		for (var i=0;i < autolinks.length; i++){
			if(autolinks[i].className == "al"){
				var p = autolinks[i].innerHTML;
				p = p.replace(/<b class=al>/ig,"").replace(/<\/b>/ig,"");
				autolinks[i].innerHTML = 
					"<a href='#" + encodeURI(p)
					+ "' onclick=\"loadpage('" + encodeURI(p) + "');return false\">"
					+ p + "</a>";
			}
		}
		return tmp_div.innerHTML;
	};
	if(o){for(i in o){this[i]=o[i]}}
	return this;
}
autolink = new AutoLink();

